// Class   : ByteCopier
// Author  : Russ Ethington
// Version : 2/25/98 for Java 1.1

import java.util.*;
import java.net.*;
import java.io.*;

public class ByteCopier extends Thread
{
    InputStream in = null;
    OutputStream out = null;
    LineListener listener = null;

    public ByteCopier(InputStream input, OutputStream output)
    {
        in = input;
        out = output;
        listener = null;
    }

    public ByteCopier(InputStream input, OutputStream output, LineListener aListener)
    {
        in = input;
        out = output;
        listener = aListener;
    }

    public void run()
    {
        while (true)
        {
            try
            {
                int data = in.read();
                if (data == -1)
                {
                    out.write(data);
                    break;
                }

                if (listener != null)
                    listener.dataAlert(data);
                out.write(data);
            }
            catch (IOException e)
            {
                break;
            }
        }
    }
}