// Class   : DataLogger
// Author  : Russ Ethington
// Version : 2/25/98 for Java 1.1

import java.util.*;
import java.net.*;
import java.io.*;

public class DataLogger implements LineListener
{
   int lineCount = 0;
   final int LineLength = 80;
   FileOutputStream file = null;

   public DataLogger(int uniqueId, String direction)
   {
      try
      {
         // Make the names sortable by connection identifier.
         String padded = "";
         String number = Integer.toString(uniqueId);
         if (uniqueId < 10)
            padded = "000" + number;
         else if (uniqueId < 100)
            padded = "00" + number;
         else if (uniqueId < 1000)
            padded = "0" + number;
         else
            padded = number;

         file = new FileOutputStream("Data." + padded + "." + direction + ".txt");
      }
      catch (Exception e)
      {
         System.err.print("DataLogger: Cannot create log file.");
         file = null;
      }
   }

   public void close()
   {
      try
      {
         if (file != null) file.close();
      }
      catch (Exception e) { }
   }

   public boolean isPunctuation(char c)
   {
      String p = "`~!@#$%^&*()-_=+[{]}\\|;:'\",<.>/? \t";

      if (p.indexOf(c) < 0)
         return false;
      else
         return true;
   }

   //
   // LineListener interface
   //

   public void dataAlert(int data)
   {
      if (file == null) return;

      lineCount++;
      char c = (char) data;

      if (c == '\r')
         c = ' '; // turns "\r\n" into " \n" just for looks
      if (!Character.isLetterOrDigit(c) && !isPunctuation(c) && (c != '\n'))
         c = '.'; // turns binary data into "." to make it viewable

      try
      {
         if (lineCount > LineLength) // break up long binary segments
         {
            file.write('\r');
            file.write('\n');
            lineCount = 1;
         }

         if (c == '\n')
            lineCount = 1;
         file.write(c);
      }
      catch (IOException e) { }
   }

   public void dataAlert(String data)
   {
      if (file == null) return;

      try
      {
         file.write(data.getBytes());
      }
      catch (IOException e) { }
   }
}
