/************************************************************
*          This is a part of the VideoClick project.
*               Copyright (C) 1998 Vsoft Ltd.
*                   All rights reserved.
* NAME: INamedObject2
*
* Description: 
* This interface can be exposed by a COM object that exposes some 
* friendly identifying properties.
*
* Author: Noam Cohen Oct 2000
*
* $Archive: /VideoClick2.1/Utils/ComWiz/Template/Interface.h $
* $Revision: 1 $
* $Author: Noam $
* $JustDate: 22/08/99 $
************************************************************/

#ifndef _INamedObject2_H
#define _INamedObject2_H

#include <objbase.h>

// {4F4139B8-3E02-4533-949B-5C4DB647C596}
static const GUID IID_INamedObject2 = 
{ 0x4f4139b8, 0x3e02, 0x4533, { 0x94, 0x9b, 0x5c, 0x4d, 0xb6, 0x47, 0xc5, 0x96 } };


/*
This interface can be exposed by a COM object that exposes some identifying properties.
*/
interface INamedObject2 : IUnknown
{

	/*------------------------------------------------------------------------
	Get a name for this object's clas ( e.g. "TS demuxer" )
	Return: 
		null terminated string
	*/
	virtual const char* GetClassName() = 0;

	/*------------------------------------------------------------------------
	Get the CLASS id of this COM object.
	It is recommended to return the CLSID used when creating this object

	Return: 
		S_OK
		E_NOTIMPL
	*/
	virtual HRESULT GetClassId(const GUID &) = 0;

	/*------------------------------------------------------------------------
	Get a name for this object ( e.g. "object in server 34" )
	Return: 
		null terminated string
	*/
	virtual const char* GetObjectName() = 0;

	/*------------------------------------------------------------------------
	Get the INSTANCE id of this COM object.

	Return: 
		S_OK
		E_NOTIMPL
	*/
	virtual HRESULT GetObjectId(const GUID &) = 0;
}; // INamedObject2


// helper macro for those lazy people who need minimal functionality
#define CLASS_NAME_IMPL(szClassName) \
	const char* GetClassName(){return szClassName;} \
	HRESULT GetClassId(const GUID &){ return E_NOTIMPL;}\
	const char* GetObjectName(){return "";}\
	HRESULT GetObjectId(const GUID &){ return E_NOTIMPL;}

#endif
