// Class   : LineCopier
// Author  : Russ Ethington
// Version : 2/25/98 for Java 1.1

import java.util.*;
import java.net.*;
import java.io.*;

public class LineCopier extends Thread
{
    DataInputStream in = null;
    PrintStream out = null;
    LineListener listener = null;
    
    public LineCopier(InputStream input, OutputStream output)
    {
        in = new DataInputStream(new BufferedInputStream(input));
        out = new PrintStream(new BufferedOutputStream(output), true);
        listener = null;
    }

    public LineCopier(InputStream input, OutputStream output, LineListener aListener)
    {
        in = new DataInputStream(new BufferedInputStream(input));
        out = new PrintStream(new BufferedOutputStream(output), true);
        listener = aListener;
    }
        
    public void run()
    {
        while (true)
        {
            try
            {
                String line = in.readLine();
                if (line == null) 
                    break;
                    
                if (listener != null)
                    listener.dataAlert(line);
                out.println(line);
            }
            catch (IOException e)
            {
                break;
            }
        }                
    }
}