//  CLASS TTOOLBAR
//  Main class for the application. Everything starts here.
//  We create all of the 12 windows (derived from TChartForm)
//  and pass them the data, as well as maintain everything
//  affetcting those datas such as reading new incoming files, etc.
//
// (C) Steve JORDI - 1996-1999  
// steve@sjordi.com - www.sjordi.com
//
//  All this code is copyrighted by Steve Jordi and
//  cannot be reproduced without consent of the author.
//  The executable may be freely distributed.
//
//  THIS PROGRAM  IS  PROVIDED  "AS IS"  WITHOUT  WARRANTY OF ANY
//  KIND, EITHER EXPRESSED OR IMPLIED, INCLUDING, BUT NOT LIMITED
//  TO  THE  IMPLIED  WARRANTIES  OF MERCHANTABILITY  AND FITNESS
//  FOR  A  PARTICULAR PURPOSE. THE ENTIRE RISK AS TO THE QUALITY
//  AND   PERFORMANCE  OF  THE  PROGRAM  IS  WITH YOU. SHOULD THE
//  PROGRAM  PROVE   DEFECTIVE,  YOU   (NOT  STEVE JORDI)  ASSUME
//  THE ENTIRE COST OF ALL  NECESSARY   SERVICING,   REPAIR,   OR
//  CORRECTION. IN NO EVENT WILL STEVE JORDI BE LIABLE TO YOU FOR
//  ANY  DAMAGES ,  INCLUDING ANY LOST PROFITS,  LOST SAVINGS, OR
//  OTHER INCIDENTAL OR CONSEQUENTIAL DAMAGES  ARISING OUT OF THE
//  USE OR INABILITY TO USE  SUCH  PROGRAM  EVEN  IF  STEVE JORDI
//  HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES,  OR FOR
//  ANY  CLAIM BY ANY OTHER PARTY.
//---------------------------------------------------------------------------
#ifndef MainH
#define MainH
//---------------------------------------------------------------------------
#include <vcl\Classes.hpp>
#include <vcl\Controls.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Forms.hpp>
#include "explbtn.hpp"
#include "splashform.h"
#include <vcl\ExtCtrls.hpp>
#include <vcl\FileCtrl.hpp>
#include <fstream.h>
#include <dir.h>
#include "marsCap.hpp"
#include "config.h"
#include "Battery.h"
#include "ExplBtn.hpp"


// Define constants for each chart window position
#define  TILT1X         0
#define  TILT1Y         Top+Height

#define  TILT2X         CHARTRIGHT/4
#define  TILT2Y         Top+Height

#define  TILT1TANX      0
#define  TILT1TANY      Top+Height+CHARTHEIGHT/3

#define  TILT2TANX      CHARTRIGHT/4
#define  TILT2TANY      Top+Height+CHARTHEIGHT/3

#define  DEFAULTWIDTH   CHARTRIGHT/4 -1
#define  DEFAULTHEIGHT  CHARTHEIGHT/3-1

// Type of specific display
#define  ALL            0
#define  TILTMETERS     1
#define  PO2            2
#define  TEMPERATURES   3

// IDs of each charts
#define  CRATER         0
#define  TILT1          1
#define  TILT2          2
#define  TILT1BATT      3
#define  TILT2BATT      4
#define  TILT1TAN       5
#define  TILT2TAN       6
#define  TEMPFUM1       7
#define  TEMPFUM2       8
#define  PO2S1WIN       9
#define  PO2S2WIN       10
#define  OXIDS1         11
#define  OXIDS2         12



//---------------------------------------------------------------------------
class TMainToolBar : public TForm
{
__published:   // IDE-managed Components
   TExplorerButton *ExitButton;
   TExplorerButton *MinimizeButton;
   TExplorerButton *MaximizeButton;
   TExplorerButton *ArrangeButton;
   TExplorerButton *TiltmetersButton;
   TExplorerButton *OxidationButton;
   TExplorerButton *DataButton;
   TExplorerButton *HelpButton;
   TExplorerButton *TemperaturesButton;
   TExplorerButton *TileButton;
   TExplorerButton *HorizontalButton;
   TExplorerButton *PrintButton;
   TExplorerButton *ConfigButton;
   TExplorerButton *BatteryButton;
   TLabel *UpdateBanner;
   TMarsCaption *MarsCaption1;
   TTimer *ClockTimer;
   void __fastcall ExitButtonClick(TObject *Sender);
   void __fastcall MaximizeButtonClick(TObject *Sender);
   void __fastcall TiltmetersButtonClick(TObject *Sender);
   void __fastcall ArrangeButtonClick(TObject *Sender);
   void __fastcall TileButtonClick(TObject *Sender);
   void __fastcall HorizontalButtonClick(TObject *Sender);
   
   void __fastcall MinimizeButtonClick(TObject *Sender);
   void __fastcall OxidationButtonClick(TObject *Sender);
   void __fastcall TemperaturesButtonClick(TObject *Sender);

   void __fastcall HelpButtonClick(TObject *Sender);
   void __fastcall ConfigButtonClick(TObject *Sender);
   void __fastcall DataButtonClick(TObject *Sender);


   void __fastcall ClockTimerTimer(TObject *Sender);
   
   
   
   void __fastcall BatteryButtonClick(TObject *Sender);


   
   void __fastcall PrintButtonClick(TObject *Sender);
   void __fastcall FormCreate(TObject *Sender);

private: // User declarations
   TChartForm* Tilt1 ;
   TChartForm* Tilt2 ;
   TChartForm* Tilt1Tan ;
   TChartForm* Tilt2Tan ;
   TChartForm* PO2S1 ;
   TChartForm* PO2S2 ;
   TChartForm* TempFum1 ;
   TChartForm* TempFum2 ;
   TChartForm* Tilt1Batt;
   TChartForm* Tilt2Batt;
   TChartForm* OxidS1 ;
   TChartForm* OxidS2 ;
   TBatteryForm* BatteryForm ;

   TConfigure* Configure ;
   // Now declare dummy variables which will be used
   // to read data from files
   // We name them val1, val2, etc... and they will just
   // be equivalent to
   // Tilt: vbat2, vbat1, tElec, TJct, ...
   // REL : vbat, H, M, DD, MM, YY
   // CRA : vbat2, vbat1, tElec, TJct, ...
   int   val1, val2, val3, val4, val5, val6, val7,
         val8, val9, val10, val11, val12, val13, val14 ;
   int   dataHour, dataMinute, dataDay, dataMonth, dataYear ;
   Word  MSec, Second, Hour, Minute, Day, Month, Year ;
   Word  lastHour, lastMinute, lastDay, lastMonth, lastYear ;
   int   VBat1, VBat2, TElec, TAmb, TJct, TJauge2, TThermo2, TJauge1, TThermo1 ;
   int   YTang, Y10Tang, XRad, X10Rad ;
   AnsiString fileName ;
   fstream     outFile ; // Used to store filtered data
   fstream     newFile ; // Used to store new data only
   bool        firstCompare ;
   int         currentActiveWindow ;
   int         currentDisplay ;
   bool        clockMode ;
   bool        newData ;
   bool        craSucceed, tilt1Succeed, tilt2Succeed ;
   AnsiString  prefix ;
   AnsiString  initMessage ;
   AnsiString  dir ;
   short       lastMonthFound ;

   // Functions (see cpp file)
   void        ReadFiles( AnsiString, AnsiString, int ) ;
   void        ProcessFiles() ;
   void        ScanData( char* ) ;
   void        SearchDay( short month, short maxDay ) ;
   void        SearchHour( short month, short day, short maxHour ) ;
   int         dataType ;
   void        UpdateFiles() ;
   void        GetLastInfo() ;

   // Timer variables
   TDateTime   nextUpdate ;
   bool        initDone ;

public:     // User declarations
   __fastcall  TMainToolBar(TComponent* Owner);
   void        SetCurrentWindow( int ) ;

};
//---------------------------------------------------------------------------
extern TMainToolBar *MainToolBar;
//---------------------------------------------------------------------------
#endif
