// oddword.cpp : Defines the entry point for the console application.
//
#include <iostream.h>
#include <string>
#include "CCoroutine.h"
#ifdef _WIN32
#include "CWinNTCoroutine.h"
#else
#include "CSolarisCoroutine.h"
#endif

CTargetPlatformCoroutine *rwrd;
CTargetPlatformCoroutine *rspc;
CTargetPlatformCoroutine *prtn;
std::string InputString;
int InputPointer = 0;
int k;
char Word1[20];

class ReadWord : public CTargetPlatformCoroutine
{
public:
	ReadWord() : CTargetPlatformCoroutine() {this->initialize();}
	virtual void go();
};

class ReadSpace : public CTargetPlatformCoroutine
{
public:
	ReadSpace() : CTargetPlatformCoroutine() {this->initialize();}
	virtual void go();
};

class PrintRoutine : public CTargetPlatformCoroutine
{
public:
	PrintRoutine() : CTargetPlatformCoroutine() {this->initialize();}
	virtual void go();
};

void ReadWord::go()
{
	char ch;
	while (true)
    {
        k = 0;
		memset(Word1, 0, 20);
		ch = InputString[InputPointer];
		while (ch != ' ' && ch != '.' && k < 20)
		{
			Word1[k] = ch;
			k++;
			InputPointer++;
			ch = InputString[InputPointer];
		}
		resume(prtn);

	}
}

void ReadSpace::go()
{
	while (true)
	{
		 bool bSawSpace = false;
		 if (InputPointer >= InputString.length())
			 return;

		 // assume that this thing ends with '.'
		 while (InputString[InputPointer] == ' ')
		 {
			 InputPointer++;
			 bSawSpace = true;
		 }

		 if (InputString[InputPointer] == '.')
		 {
			 cout << "." << endl;
			 exit(0);
		 }
		 else
		 {
			 if (bSawSpace)
			     cout << " ";
			 resume(rwrd);
		 }
	}
}

void PrintRoutine::go()
{
    int j;

	while (true)
	{
		for (j = 0; j < k; j++)
			cout << Word1[j];
		resume(rspc);
		for (j = k - 1; j >= 0; j--)
			cout << Word1[j];
		resume(rspc);
	}
}


// Let the user enter a string on the command line
// Store it in memory in the variable InputString
// then read characters one at a time from InputString
// to solve the odd word problem
// Make sure to enclose your command line argument in double quotes

int main(int argc, char* argv[])
{
	if (argc != 2)
	{
		InputString = "whats      the     matter with Kansas.";
	}
	else
	{
        InputString = argv[1];
	}

	rwrd = new ReadWord();
	rspc = new ReadSpace();
	prtn = new PrintRoutine();

	rspc->go();
	return 0;
}